#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/FMclick/FMclick.c"
#line 64 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/FMclick/FMclick.c"
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D4 at RB0_bit;


sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;






signed char powerOn;
unsigned char Rssi;
unsigned int freq;
unsigned char volume;
unsigned char RDS_ok;
unsigned char country_code;
unsigned char coverage;
unsigned char program_ref;
unsigned int ChipID;
unsigned char SelectD;
unsigned char old_SelectD;
unsigned char text5[7];
unsigned int index;
unsigned char rds_pty;
unsigned int block_err_name;
unsigned char block_err_sum;
unsigned char stereo;
unsigned char str_size;
unsigned char flag_RDS;
unsigned char flag_Clock;
unsigned char RDS_text[9];
unsigned char debug_text[11];
unsigned char info_text[65];
unsigned char local_hour;
unsigned char local_minute;
unsigned char local_day;
unsigned char local_month;
unsigned char local_year;
unsigned char len_month[13] = {0, 30, 28, 31, 30, 31, 30, 31, 31, 30, 31, 31, 31};



unsigned char shadowReg[32];
#line 135 "C:/PIC/MikroC/PIC18/PIC18F45K22/Click/FMclick/FMclick.c"
void modShadowReg(unsigned char reg, unsigned int value, unsigned char set_reset){

unsigned char reg_pos;

 reg_pos = 12 + (reg << 1);
 if (set_reset){
 shadowReg[reg_pos] |= value>>8;
 reg_pos++;
 shadowReg[reg_pos] |= (value&0xff);
 }
 else{
 shadowReg[reg_pos] &= ( ~ ( value>>8 ) );
 reg_pos++;
 shadowReg[reg_pos] &= ( ~ ( value &0xff) );
 }
}


void FM_Write(unsigned char reg, unsigned int value, unsigned char set_reset){
unsigned char wr_cnt;
unsigned char ii;

 wr_cnt = ( reg - 1 ) << 1;
 modShadowReg(reg, value, set_reset);
 I2C1_Start();
 I2C1_wr( 0x20 );
 for (ii = 16; ii <= (16 + wr_cnt);ii++){
 I2C1_Wr(shadowReg[ii]);
 }
 I2C1_stop();
}


void FM_Read(unsigned char cmd){
unsigned char ii;

 if(cmd ==  0x0F ){
 I2C1_Start();
 I2C1_wr( 0x20  + 1 );
 for(ii = 0; ii <= 30; ii++){
 shadowReg[ii] = I2C1_rd(1);
 }
 shadowReg[31] = I2C1_rd(0);
 I2C1_Stop();
 }

 if(cmd ==  2 ){
 I2C1_Start();
 I2C1_wr( 0x20  +1 );
 for( ii = 0; ii <= 2; ii++){
 shadowReg[ii] = I2C1_rd(1);
 }
 shadowReg[3] = I2C1_rd(0);
 I2C1_Stop();
 }
}


void SetVolume(unsigned char vol){
 if ( ( vol >= 0 ) && ( vol <= 16) ) {
 vol = vol & 0x0F;
 modShadowReg(0x05, 0x000F, 0);
 FM_Write(0x05, vol, 1);
 delay_ms(5);
 }
}


void Refresh_Freq_Rds_Rssi(){
unsigned char block_errA, block_errB, block_errC, block_errD;

 FM_Read( 2 );
 freq = shadowReg[3] + 875;
 rssi = shadowReg[1];
 stereo = shadowReg[0] & 0b00000001;
 RDS_ok = (shadowReg[0] & 0b10000000) >> 7;
 block_errA = shadowReg[0];
 block_errB = (shadowReg[2] & 0b11000000 ) >> 6;
 block_errC = (shadowReg[2] & 0b00110000 ) >> 4;
 block_errD = (shadowReg[2] & 0b00001100 ) >> 2;
 block_err_name = block_errD;
 block_err_sum = block_errB + block_errC + block_errD;
 country_code = shadowReg[0] >> 4;
 coverage = shadowReg[0] & 0x0f;
 program_ref = shadowReg[1];
}


void display_fm(){
 if(stereo){
 lcd_out(1,16,"ST");
 }
 else{
 lcd_out(1,16,"  ");
 }
 wordtostr(freq,text5);
 lcd_chr(1,14,text5[4]);
 lcd_chr(1,13,'.');
 lcd_chr(1,12,text5[3]);
 lcd_chr(1,11,text5[2]);
 lcd_chr(1,10,text5[1]);
 lcd_out(4,1,"Rssi: ");
 Lcd_Chr(4,7,(rssi / 10) + 48);
 Lcd_Chr(4,8,(rssi % 10) + 48);
 lcd_out(4,14,"Vol:");
 Lcd_Chr(4,19,(volume / 10) + 48);
 Lcd_Chr(4,20,(volume % 10) + 48);

 if(SelectD == 0){
 Lcd_Chr(2,7,(rssi / 10) + 48);
 Lcd_Chr(2,8,(rssi % 10) + 48);
 Lcd_Chr(2,15,(volume / 10) + 48);
 Lcd_Chr(2,16,(volume % 10) + 48);
 }
 if(SelectD == 2){
 lcd_out(2,1,"Pty ");
 Lcd_Chr(2,5,(rds_pty / 10) + 48);
 Lcd_Chr(2,6,(rds_pty % 10) + 48);
 switch(rds_pty){
 case 1:
 Lcd_Out(2, 8, "news     ");
 break;
 case 5:
 Lcd_Out(2, 8, "education");
 break;
 case 6:
 Lcd_Out(2, 8, "drama    ");
 break;
 case 7:
 Lcd_Out(2, 8, "culture  ");
 break;
 case 8:
 Lcd_Out(2, 8, "science  ");
 break;
 case 9:
 Lcd_Out(2, 8, "varied   ");
 break;
 case 10:
 Lcd_Out(2, 8, "pop music");
 break;
 case 11:
 Lcd_Out(2, 8, "rock     ");
 break;
 case 14:
 Lcd_Out(2, 8, "classical");
 break;
 default:
 Lcd_Out(2, 8, "         ");
 break;
 }
 }
 if(SelectD == 4){
 ByteToStr(country_code,debug_text);
 Lcd_Out(2, 14, debug_text);
 }
 if(SelectD == 5){
 ByteToStr(coverage,debug_text);
 Lcd_Out(2, 14, debug_text);
 }
 if(SelectD == 6){
 ByteToStr(program_ref,debug_text);
 Lcd_Out(2, 14, debug_text);
 }
}


void FM_Tune(unsigned int freq){
unsigned int calc;
signed char STC_bit;
 STC_bit = 0;
 calc = freq;
 calc = calc - 875;
 calc = calc | 0x8000;
 if (powerON == 1){
 FM_Read( 2 );
 modShadowReg(0x03, 0x83FF, 0);
 FM_Write(0x03, calc, 1);
 Delay_ms(60);
 while (STC_bit == 0){
 FM_Read( 2 );
 STC_bit = shadowReg[0] & 0x40;
 }
 FM_Read( 2 );
 modShadowReg(0x03, 0x8000, 0);
 FM_Write(0x03, 0x8000, 0);
 while (STC_bit > 0){
 FM_Read( 0x0F );
 STC_bit = shadowReg[0] & 0x40;
 }
 }
 else{
 ModShadowReg(0x03, calc, 1);
 }
}


void FM_Seek(unsigned char direction){
signed char STC_bit, SF_BL_bit;
 if (direction == 1){
 modShadowReg(0x02, 0x0300, 0);
 FM_Write(0x02, 0x0300, 1);
 }
 else{
 modShadowReg(0x02, 0x0300, 0);
 FM_Write(0x02, 0x0100, 1);
 }
 STC_bit = 0 ;
 while( STC_bit == 0 ){
 FM_Read( 2 );
 STC_bit = (shadowReg[0] & 0b01000000) >> 6;
 delay_ms(60);
 }
 modShadowReg(0x02, 0x0300, 0);
 FM_Write(0x02, 0x0100, 0);
 while( STC_bit == 1 ){
 FM_Read( 2 );
 STC_bit = (shadowReg[0] & 0b01000000) >> 6;
 }
 FM_Read( 2 );
 SF_BL_bit = (shadowReg[0] & 0b00100000) >> 5;
}

void Rds_scan(){
unsigned char Ah, Al, Bh, Bl, Ch, Cl, Dh, Dl;
unsigned char pos;
unsigned char service;
signed int utc_offset;
signed int rds_hours;
signed int rds_minutes;
unsigned long mjulian_days;
unsigned long wdrds;
unsigned char leap;

 RDS_text[8] = 0;

 if(RDS_ok){

 FM_Read( 0x0F );
 Ah = shadowReg[4];
 Al = shadowReg[5];
 Bh = shadowReg[6];
 Bl = shadowReg[7];
 Ch = shadowReg[8];
 Cl = shadowReg[9];
 Dh = shadowReg[10];
 Dl = shadowReg[11];
 service = Bh & 0b11111000;

 if (service == 0){
 if (block_err_name < 3){
 pos = Bl & 3;
 if( pos == 0){
 if( str_size == 8){
 flag_RDS = 1;
 }
 else{
 if( RDS_text[0] == 0){
 RDS_text[0] = Dh;
 RDS_text[1] = Dl;
 str_size = str_size + 2;
 }
 }
 }
 else{
 if( (pos == 1) && (RDS_text[2] == 0)){
 RDS_text[2] = Dh;
 RDS_text[3] = Dl;
 str_size = str_size + 2;
 }
 if( (pos == 2) && (RDS_text[4] == 0)){
 RDS_text[4] = Dh;
 RDS_text[5] = Dl;
 str_size = str_size + 2;
 }
 if( (pos == 3) && (RDS_text[6] == 0)){
 RDS_text[6] = Dh;
 RDS_text[7] = Dl;
 str_size = str_size + 2;
 }
 }
 rds_pty = (((Bh & 3) *4)+(Bl>>5) & 0x1f);
 }
 }


 if((service == 0x20) || (service == 28)){
 if( block_err_sum < 1){
 pos = BL & 0x0f;
 info_text[pos*4] = CH;
 info_text[pos*4 + 1] = CL;
 info_text[pos*4 + 2] = DH;
 info_text[pos*4 + 3] = DL;
 if(selectD == 8){
 for( pos = 0 ; pos < 16;pos++){
 LCD_Chr(2,pos+1,info_text[pos]);
 }
 }
 if(selectD == 9){
 for( pos = 0 ; pos < 16;pos++){
 LCD_Chr(2,pos+1,info_text[pos+16]);
 }
 }
 if(selectD == 10){
 for( pos = 0 ; pos < 16;pos++){
 LCD_Chr(2,pos+1,info_text[pos+32]);
 }
 }
 if(selectD == 11){
 for( pos = 0 ; pos < 16;pos++){
 LCD_Chr(2,pos+1,info_text[pos+48]);
 }
 }
 }
 }


 if( service == 0x40){
 if( block_err_sum == 0){
 mjulian_days = (32768ul * (Bl & 0x03)) + (128 * Ch) + (Cl >> 1);
 utc_offset = (Dl & 0x1f) >> 1;
 rds_minutes = ((Dh & 0x0f) << 2) + ((Dl & 0xc0) >> 6);
 rds_hours = ((Cl & 0x01) << 4) + ((Dh & 0xf0) >> 4);
 if (Dl & 0x20){
 rds_hours -= utc_offset;
 }
 else{
 rds_hours += utc_offset;
 }
 if( rds_hours >= 24){
 rds_hours -= 24;
 mjulian_days += 1;
 }
 if( rds_hours < 0){
 rds_hours += 24;
 mjulian_days += 1;
 }



 if(SelectD == 3){
 longwordtostr(mjulian_days,debug_text);
 lcd_out(2,2,debug_text);
 }
 if(SelectD == 1){
 mjulian_days -= 58119ul;
 local_year = 18;
 local_month = 1;
 local_day = 1;
 leap = 0;


 while(mjulian_days > 31){
 if(mjulian_days > (len_month[local_month] + leap)){
 mjulian_days -= (len_month[local_month] + leap);
 local_month += 1;
 if(local_month > 12){
 local_month = 1;
 local_year += 1;
 }
 leap = 0;
 if (local_month == 2){
 if(local_year == 20) leap = 1;
 if(local_year == 24) leap = 1;
 if(local_year == 28) leap = 1;
 if(local_year == 32) leap = 1;
 if(local_year == 36) leap = 1;
 if(local_year == 40) leap = 1;
 if(local_year == 42) leap = 1;
 }
 }
 local_day = mjulian_days;
 }
 }


 local_minute = rds_minutes;
 local_hour = rds_hours;
 flag_Clock = 1;
 }
 }
 }
}

unsigned char FM_Activate(){
unsigned int active;

 active = ChipID;
 FM_Read( 0x0F );
 modShadowReg(0x02, 0x4801, 0);
 FM_Write(0x02, 0x4801, 1);
 Delay_ms(200);
 while (active == ChipID){
 FM_Read( 0x0F );
 active = shadowReg[14] << 8;
 active = active | shadowReg[15];
 }
 modShadowReg(0x04, 0xFFFF, 0);
 FM_Write(0x04,0x1800,1);
 modShadowReg(0x05, 0xFFFF, 0);
 FM_Write(0x05, 0x101F, 1);
 Delay_ms(110);
 powerOn = 1;
 return shadowReg[0];
}

void FM_Deactivate(){
 modShadowReg(0x02 , 0x4000, 0 );
 FM_Write(0x02, 0x0040, 1);
 powerOn = 0;
}


void FMClick_Init(){
  LATE1_bit  = 1;
 Delay_ms(1);
 I2C1_Init(100000);
 FM_Read( 0x0F );
 ChipID = shadowReg[14] * 256;
 ChipID = ChipID | shadowReg[15];
 Delay_ms(1);
 modShadowReg(0x07, 0x0081, 0);
 FM_Write(0x07, 0x8100, 1);
 Delay_ms(500);
}

void init_RDS (unsigned char efface){
 if (efface == 1){
 lcd_out(3,1,"                    ");
 if(SelectD == 2){
 lcd_out(2,1,"                    ");
 }
 lcd_out(1,1,"        ");
 rds_pty = 0;
 }
 RDS_text[0] = 0;
 for (index = 0; index <= 7 ; index++){
 RDS_text[index] = 0;
 }
 flag_RDS = 0;
 flag_Clock = 0;
 str_size = 0;
}

void display_time (unsigned char col ){
 if(SelectD == 1){
 Lcd_Chr(2,col,local_hour / 10 + 48);
 Lcd_Chr(2,col+1,(local_hour % 10) + 48);
 Lcd_chr(2,col+2,':');
 Lcd_Chr(2,col+3,(local_minute / 10) + 48);
 Lcd_Chr(2,col+4,(local_minute % 10) + 48);
 Lcd_chr(2,col+5,' ');
 }
}

void display_date (unsigned char col ){
 if(SelectD == 1){
 Lcd_Chr(2,col, (local_day / 10) + 48);
 Lcd_Chr(2,col+1, (local_day % 10) + 48);
 Lcd_chr(2,col+2,'-');
 Lcd_Chr(2,col+3, (local_month / 10) + 48);
 Lcd_Chr(2,col+4, (local_month % 10) + 48);
 Lcd_out(2,col+5,"-20");
 Lcd_Chr(2,col+8, (local_year / 10) + 48);
 Lcd_Chr(2,col+9, (local_year % 10) + 48);
 }
}


void Clear_Info(){
char pos;

 for(pos = 0; pos < 65 ; pos++){
 info_text[pos] = ' ';
 }
}


void debounce(){
 Delay_ms(100);
}


void main(){

 PLLEN_bit = 0;

 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
 SLRCON = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 TRISD = 0xff;

 TRISA0_bit = 0;
 LATA0_bit = 1;
 TRISA1_bit = 1;
 TRISA2_bit = 1;

 TRISE1_bit = 0;
  LATE1_bit  = 0;
 Delay_ms(1);
 TRISE0_bit = 0;
  LATE0_bit  = 1;
 Delay_ms(1);
 TRISC4_bit = 0;
  LATC4_bit  = 0;
 Delay_ms(1);
 TRISC3_bit = 0;
  LATC3_bit  = 0;
 Delay_ms(1);

 Delay_ms(200);

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Lcd_out(1,1,"BOURDON FM Click");
 FMClick_Init();
 Lcd_out(1,1,"init.. ");
 FM_activate();
 lcd_out(1,1,"    Wait Freq...");
 FM_Tune(1036);
 lcd_out(1,1,"      Tuned !   ");

 SelectD = 0;
 old_SelectD = 0xff;
 volume = 2;
 setVolume(volume);
 delay_ms(5);

 delay_ms(2000);
 lcd_cmd(_lcd_clear);
 init_RDS(0);
 rds_pty = 0;

 while(1){

 if( !PORTD.B0){
 init_RDS(1);
 FM_Seek(1);
 Debounce();
 }

 if( !PORTD.B1){
 init_RDS(1);
 FM_Seek(0);
 Debounce();
 }

 if( !PORTD.B2){
 if( volume <15){
 volume = volume + 1;
 }
 Setvolume(volume);
 Debounce();
 }

 if( !PORTD.B3){
 if( volume > 0){
 volume = volume - 1;
 }
 SetVolume(volume);
 Debounce();
 }

 if( !PORTD.B4){
 SelectD++;
 Debounce();
 }

 if( !PORTD.B5){
 SelectD--;
 Debounce();
 }

 Refresh_Freq_Rds_Rssi();
 display_fm();
 Rds_scan();
 if( flag_RDS == 1){
 lcd_out(1,1,RDS_text);
 init_RDS(0);
 }
 if(flag_Clock){
 display_time(1);
 display_date(7);
 }

 LATA0_bit = ~LATA0_bit;

 if(old_SelectD != SelectD){
 SelectD &= 0x0f;
 old_SelectD = SelectD;
 switch(SelectD){
 case 0:{
 LCD_Out(2,1,"Rssi:    Vol:   ");
 break;
 }
 case 1:{
 LCD_Out(2,1,"Time and Date...");
 break;
 }
 case 2:{
 LCD_Out(2,1,"Pty             ");
 break;
 }
 case 3:{
 LCD_Out(2,1," mod Julian days");
 break;
 }
 case 4:{
 LCD_Out(2,1,"country code    ");
 break;
 }
 case 5:{
 LCD_Out(2,1,"area coverage   ");
 break;
 }
 case 6:{
 LCD_Out(2,1,"Program ref     ");
 break;
 }
 case 8:{
 LCD_Out(2,1," Info text 0    ");
 Clear_Info();
 break;
 }
 case 9:{
 LCD_Out(2,1," Info text 1    ");
 Clear_Info();
 break;
 }
 case 10:{
 LCD_Out(2,1," Info text 2    ");
 Clear_Info();
 break;
 }
 case 11:{
 LCD_Out(2,1," Info text 3    ");
 Clear_Info();
 break;
 }
 default:{
 LCD_Out(2,1,"Version 290618b ");
 break;
 }
 }
 }
 }

}
